﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static System.Windows.Forms.VisualStyles.VisualStyleElement;

namespace AirPlaneWithRadar
{
    internal class DrawingRadarPlane : DrawingPlain
    {
        public DrawingRadarPlane(int speed, float weight, Color bodyColor, Color dopColor, bool radar, bool oilBox) : base(speed, weight, bodyColor, 110, 60)
        {
            Plain = new RadioPlane(speed, weight, bodyColor, dopColor, radar, oilBox);
        }

        public void ReColorDop(Color dopCol)
        {
            (Plain as RadioPlane).DopColor = dopCol;
        }
        public override void DrawTransoprt(Graphics g)
        {
            if (Plain is not RadioPlane radioPlane)
            {
                return;
            }
            Pen pen = new(Color.Black);
            Brush doBrush = new SolidBrush(radioPlane.DopColor);
            base.DrawTransoprt(g);
            if (radioPlane.OilBox)
            {
                g.DrawRectangle(pen, startPosX + 40, startPosY + 48, 20, 10);
                g.FillRectangle(doBrush, startPosX + 40, startPosY + 48, 20, 10);

                g.DrawRectangle(pen, startPosX, startPosY + 15, 30, 10);
                g.FillRectangle(doBrush, startPosX, startPosY + 15, 30, 10);
            }
            if (radioPlane.Radar)
            {
                g.FillRectangle(doBrush, startPosX + 55, startPosY + 20, 10, 10);
                g.FillEllipse(doBrush, startPosX + 40, startPosY + 13, 40, 10);
            }

        }
    }
}
