namespace AirPlaneWithRadar
{
    
    public partial class FormPlain : Form
    {
        private DrawingPlain _plain;
        public DrawingPlain SelectedPlain { get; private set; }
        public FormPlain()
        {
            InitializeComponent();

        }

        private void Draw()
        {
            Bitmap bmp = new(pictureBoxPlain.Width, pictureBoxPlain.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _plain?.DrawTransoprt(gr);
            pictureBoxPlain.Image = bmp;
        }
        private void SetData()
        {
            Random rnd = new();
            _plain.setPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxPlain.Width, pictureBoxPlain.Height);
            toolStripStatusLabelSpeed.Text = $": {_plain.Plain.Speed}";
            toolStripStatusLabelWeight.Text = $": {_plain.Plain.Weight}";
            toolStripStatusLabelColor.Text = $": {_plain.Plain.BodyColor.Name}";
        }
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            _plain = new DrawingPlain(rnd.Next(100, 300), rnd.Next(1000, 2000), color);
            SetData();
            Draw();
        }
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _plain?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _plain?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _plain?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _plain?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }

        private void PictureBoxPlain_Resize(object sender, EventArgs e)
        {
            _plain?.ChangeBorders(pictureBoxPlain.Width, pictureBoxPlain.Height);
            Draw();
        }

        private void buttonCreateModif_Click(object sender, EventArgs e)
        {

            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            Color dopColor = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialogDop = new();
            if (dialogDop.ShowDialog() == DialogResult.OK)
            {
                dopColor = dialogDop.Color;
            }
            _plain = new DrawingRadarPlane(rnd.Next(100, 300), rnd.Next(1000, 2000),
                color,
                dopColor,
               Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData();
            Draw();
        }
        private void buttonSelect_Click(object sender, EventArgs e)
        {
            SelectedPlain = _plain;
            DialogResult = DialogResult.OK;
        }
    }
  }

