﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirPlaneWithRadar
{
    internal class MapsCollection
    {
        readonly Dictionary<string, MapWithSetPlainGeneric<DrawingObjectPlane, AbstractMap>> _mapStorages;

        public List<string> Keys => _mapStorages.Keys.ToList();

        private readonly int _pictureWidth;

        private readonly int _pictureHeight;

        public MapsCollection(int pictureWidth, int pictureHeight)
        {
            _mapStorages = new Dictionary<string, MapWithSetPlainGeneric<DrawingObjectPlane, AbstractMap>>();
            _pictureWidth = pictureWidth;
            _pictureHeight = pictureHeight;
        }

        public void AddMap(string name, AbstractMap map)
        {
            
           if (_mapStorages.ContainsKey(name))
                return;
            _mapStorages.Add(name, new MapWithSetPlainGeneric<DrawingObjectPlane, AbstractMap>(_pictureWidth, _pictureHeight, map));

        }

        public void DelMap(string name)
        {
         
            _mapStorages.Remove(name);
        }

        public MapWithSetPlainGeneric<DrawingObjectPlane, AbstractMap> this[string ind]
        {
            get
            {

                if (!_mapStorages.ContainsKey(ind))
                    return null;
                else
                    return _mapStorages[ind];
            }
        }
    }
}
