﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirPlaneWithRadar
{
    internal class UserMap_BigBox : AbstractMap
    {
        Brush barrierColor = new SolidBrush(Color.DarkGray);
        Brush roadColor = new SolidBrush(Color.Aqua);
        protected override void DrawBarrierPart(Graphics g, int i, int j)
        {
            g.FillRectangle(barrierColor, i * _size_x, j * _size_y, i * (_size_x + 1), j * (_size_y + 1));
        }

        protected override void DrawRoadPart(Graphics g, int i, int j)
        {
            g.FillRectangle(roadColor, i * _size_x, j * _size_y, i * (_size_x + 1), j * (_size_y + 1));
        }

        protected override void GenerateMap()
        {
            _map = new int[100, 100];
            _size_x = (float)_width / _map.GetLength(0);
            _size_y = (float)_height / _map.GetLength(1);
            int sizeKub = 5;
            int counter = 0;
            for (int i = 0; i < _map.GetLength(0); ++i)
            {
                for (int j = 0; j < _map.GetLength(1); ++j)
                {
                    _map[i, j] = _freeRoad;
                }
            } while (counter < 10)
            {
                Random rand = new Random();
                int i = rand.Next(0, 100);
                int j = rand.Next(0, 100);
                if (i > _map.GetLength(0) - sizeKub || j > _map.GetLength(0) - sizeKub)
                    continue;
                for (int iKub = i; iKub < i + sizeKub; iKub++)
                {
                    for (int jKub = j; jKub < j + sizeKub; jKub++)
                    {
                        _map[iKub, jKub] = _barrier;
                    }
                }
                counter++;
            }

        }
    }
}
